# Introduction

-   [Introduction](/docs/intro)
    -   [What is Perseus?](/docs/what-is-perseus)
    -   [Hello World!](/docs/hello-world)
-   [Your Second App](/docs/second-app)

---

# Reference

-   [`define_app!`](/docs/define-app)
-   [Writing Views](/docs/views)
-   [Debugging](/docs/debugging)
-   [Templates and Routing](/docs/templates/intro)
    -   [Modifying the `<head>`](/docs/templates/metadata-modification)
    -   [Modifying HTTP Headers](/docs/templates/setting-headers)
-   [Error Pages](/docs/error-pages)
-   [Static Content](/docs/static-content)
-   [Internationalization](/docs/i18n/intro)
    -   [Defining Translations](/docs/i18n/defining)
    -   [Using Translations](/docs/i18n/using)
    -   [Translations Managers](/docs/i18n/translations-managers)
    -   [Other Translation Engines](/docs/i18n/other-engines)
-   [Rendering Strategies](/docs/strategies/intro)
    -   [Build State](/docs/strategies/build-state)
    -   [Build Paths](/docs/strategies/build-paths)
    -   [Request State](/docs/strategies/request-state)
    -   [Revalidation](/docs/strategies/revalidation)
    -   [Incremental Generation](/docs/strategies/incremental)
    -   [State Amalgamation](/docs/strategies/amalgamation)
-   [Hydration](/docs/hydration)
-   [CLI](/docs/cli)
    -   [Ejecting](/docs/ejecting)
    -   [Snooping](/docs/snooping)
-   [Testing](/docs/testing/intro)
    -   [Checkpoints](/docs/testing/checkpoints)
    -   [Fantoccini Basics](/docs/testing/fantoccini-basics)
    -   [Manual Testing](/docs/testing/manual)
-   [Styling](/docs/styling)
-   [Communicating with a Server](/docs/server-communication)
-   [Stores](/docs/stores)
-   [Static Exporting](/docs/exporting)
-   [Plugins](/docs/plugins/intro)
    -   [Functional Actions](/docs/plugins/functional)
    -   [Control Actions](/docs/plugins/control)
    -   [Using Plugins](/docs/plugins/using)
    -   [The `tinker` Action](/docs/plugins/tinker)
    -   [Writing Plugins](/docs/plugins/writing)
    -   [Security Considerations](/docs/plugins/security)
    -   [Publishing Plugins](/docs/plugins/publishing)
-   [Deploying](/docs/deploying/intro)
    -   [Server Deployment](/docs/deploying/serverful)
    -   [Serverless Deployment](/docs/deploying/serverless)
    -   [Optimizing Code Size](/docs/deploying/size)
    -   [Relative Paths](/docs/deploying/relative-paths)
    -   [Docker Deployment](/docs/deploying/docker)
-   [Migrating from v0.2.x](/docs/updating)
-   [Common Pitfalls and Known Bugs](/docs/pitfalls-and-bugs)

---

# Advanced

-   [Under the Hood](/docs/advanced/intro)
    -   [Architecture](/docs/advanced/arch)
    -   [Initial Loads](/docs/advanced/initial-loads)
    -   [Subsequent Loads](/docs/advanced/subsequent-loads)
    -   [Routing](/docs/advanced/routing)
-   [`define_app` in Detail](/docs/advanced/define_app)
