# Introduction

-   [Introduction](/docs/intro)
    -   [What is Perseus?](/docs/what-is-perseus)
    -   [Core Principles](/docs/core-principles)
    -   [Hello World!](/docs/tutorials/hello-world)
-   [Your Second App](/docs/tutorials/second-app)

---

# Reference

-   [`PerseusApp`](/docs/reference/perseus-app)
    -   [`define_app!`](/docs/reference/define-app)
-   [Writing Views](/docs/reference/views)
    -   [The Index View](/docs/reference/index-view)
-   [Debugging](/docs/reference/debugging)
-   [Live Reloading](/docs/reference/live-reloading)
-   [Templates and Routing](/docs/reference/templates/intro)
    -   [Modifying the `<head>`](/docs/reference/templates/metadata-modification)
    -   [Modifying HTTP Headers](/docs/reference/templates/setting-headers)
    -   [Listening to the Router](/docs/reference/templates/router-state)
-   [Error Pages](/docs/reference/error-pages)
-   [Static Content](/docs/reference/static-content)
-   [Internationalization](/docs/reference/i18n/intro)
    -   [Defining Translations](/docs/reference/i18n/defining)
    -   [Using Translations](/docs/reference/i18n/using)
    -   [Translations Managers](/docs/reference/i18n/translations-managers)
    -   [Other Translation Engines](/docs/reference/i18n/other-engines)
-   [Rendering Strategies](/docs/reference/strategies/intro)
    -   [Build State](/docs/reference/strategies/build-state)
    -   [Build Paths](/docs/reference/strategies/build-paths)
    -   [Request State](/docs/reference/strategies/request-state)
    -   [Revalidation](/docs/reference/strategies/revalidation)
    -   [Incremental Generation](/docs/reference/strategies/incremental)
    -   [State Amalgamation](/docs/reference/strategies/amalgamation)
-   [Hydration](/docs/reference/hydration)
-   [Reactive State](/docs/reference/state/rx)
    -   [Global State](/docs/reference/state/global)
    -   [State Freezing](/docs/reference/state/freezing)
        -   [Freezing to IndexedDB](/docs/reference/state/idb-freezing)
    -   [Hot State Reloading (HSR)](/docs/reference/state/hsr)
-   [CLI](/docs/reference/cli)
    -   [Ejecting](/docs/reference/ejecting)
    -   [Snooping](/docs/reference/snooping)
-   [Testing](/docs/reference/testing/intro)
    -   [Checkpoints](/docs/reference/testing/checkpoints)
    -   [Fantoccini Basics](/docs/reference/testing/fantoccini-basics)
    -   [Manual Testing](/docs/reference/testing/manual)
-   [Styling](/docs/reference/styling)
-   [Communicating with a Server](/docs/reference/server-communication)
-   [Stores](/docs/reference/stores)
-   [Static Exporting](/docs/reference/exporting)
-   [Plugins](/docs/reference/plugins/intro)
    -   [Functional Actions](/docs/reference/plugins/functional)
    -   [Control Actions](/docs/reference/plugins/control)
    -   [Using Plugins](/docs/reference/plugins/using)
    -   [The `tinker` Action](/docs/reference/plugins/tinker)
    -   [Writing Plugins](/docs/reference/plugins/writing)
    -   [Security Considerations](/docs/reference/plugins/security)
    -   [Publishing Plugins](/docs/reference/plugins/publishing)
-   [Engines](/docs/reference/engines)
-   [Deploying](/docs/reference/deploying/intro)
    -   [Server Deployment](/docs/reference/deploying/serverful)
    -   [Serverless Deployment](/docs/reference/deploying/serverless)
    -   [Optimizing Code Size](/docs/reference/deploying/size)
    -   [Relative Paths](/docs/reference/deploying/relative-paths)
    -   [Docker Deployment](/docs/reference/deploying/docker)
-   [Migrating from v0.3.3](/docs/reference/updating)
-   [Common Pitfalls and Known Bugs](/docs/reference/pitfalls-and-bugs)

---

# Advanced

-   [Under the Hood](/docs/advanced/intro)
    -   [Architecture](/docs/advanced/arch)
    -   [Initial Loads](/docs/advanced/initial-loads)
    -   [Subsequent Loads](/docs/advanced/subsequent-loads)
    -   [Routing](/docs/advanced/routing)
-   [Route Announcer](/docs/advanced/route-announcer)

---

# Further Tutorials

-   [Authentication](docs/tutorials/auth)
